// template/territorySelect/territorySelect.js
Component({

    /**
     * 组件的属性列表
     */
    properties: {
        type: String, //  major subject
        list: {
            type: Object,
            observer(res) {
                // console.log("res", res);
            }
        },
        value: String,
    },

    /**
     * 组件的初始数据
     */
    data: {
        titleObj: {
            major: "请选择专业",
            subject2: "请选择专业",
            subject: "请选择学科领域",
            school: "请选择学院",
        },
    },

    /**
     * 组件的方法列表
     */
    methods: {
        select(e) {
            const key = e.currentTarget.dataset.key
            const value = e.currentTarget.dataset.value || {}

            this.triggerEvent('closeselect', {
                value,
            })
        },

        close() {
            this.triggerEvent('closeselect')
        },

        // 选择学校相关的
        selectSchool(e) {
            const label = e.currentTarget.dataset.label
            const disciplineid = e.currentTarget.dataset.disciplineid
            const university = e.currentTarget.dataset.university
            this.triggerEvent('closeselect', {
                label,
                disciplineid,
                university,
            })
        }
    }
})